sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"Exceptions","anchor":"exceptions"},{"id":"Mix Tasks","anchor":"mix-tasks"}]},{"id":"introduction-overview","title":"Overview","group":"","headers":[{"id":"Defaults","anchor":"defaults"},{"id":"Guardian","anchor":"guardian"},{"id":"Tokens in your application","anchor":"tokens-in-your-application"},{"id":"Guides","anchor":"guides"}]},{"id":"introduction-installation","title":"Installation","group":"","headers":[{"id":"Implementation Module","anchor":"implementation-module"},{"id":"Configuration","anchor":"configuration"},{"id":"Plug, Phoenix, and Guardian","anchor":"plug-phoenix-and-guardian"}]},{"id":"introduction-implementation","title":"Implementation Modules","group":"","headers":[{"id":"Usage","anchor":"usage"},{"id":"Basic Setup","anchor":"basic-setup"},{"id":"Configuration","anchor":"configuration"},{"id":"Callbacks","anchor":"callbacks"}]},{"id":"introduction-community","title":"Community","group":"","headers":[{"id":"Chat","anchor":"chat"},{"id":"Forum","anchor":"forum"}]},{"id":"tutorial-start","title":"Start","group":"","headers":[{"id":"Specify your dependencies","anchor":"specify-your-dependencies"},{"id":"Create a user manager","anchor":"create-a-user-manager"},{"id":"Create implementation module","anchor":"create-implementation-module"},{"id":"Setup Guardian config","anchor":"setup-guardian-config"},{"id":"Password hashing","anchor":"password-hashing"},{"id":"Pipelines","anchor":"pipelines"},{"id":"Controller","anchor":"controller"},{"id":"Routes","anchor":"routes"},{"id":"Try it out","anchor":"try-it-out"}]},{"id":"tokens-start","title":"Start","group":"","headers":[]},{"id":"tokens-jwt-start","title":"Start","group":"","headers":[]},{"id":"plug-start","title":"Start","group":"","headers":[]},{"id":"plug-pipelines","title":"Pipelines","group":"","headers":[{"id":"What is a Guardian Pipeline?","anchor":"what-is-a-guardian-pipeline"},{"id":"A manual version","anchor":"a-manual-version"},{"id":"Module version","anchor":"module-version"},{"id":"Changing the error handler","anchor":"changing-the-error-handler"},{"id":"Good practices","anchor":"good-practices"}]},{"id":"phoenix-start","title":"Start","group":"","headers":[]},{"id":"permissions-start","title":"Start","group":"","headers":[]},{"id":"upgrading-v1.0","title":"Upgrade guide 0.14.x to 1.0","group":"","headers":[{"id":"Implementation","anchor":"implementation"},{"id":"Configuration","anchor":"configuration"},{"id":"Sign In/Sign Out","anchor":"sign-in-sign-out"},{"id":"Pipelines","anchor":"pipelines"},{"id":"Custom Claims","anchor":"custom-claims"},{"id":"Hooks","anchor":"hooks"},{"id":"Sockets/Channels","anchor":"sockets-channels"},{"id":"Permissions","anchor":"permissions"}]}],"exceptions":[{"id":"Guardian.MalformedReturnValueError","title":"Guardian.MalformedReturnValueError","group":"","functions":[{"id":"exception/1","anchor":"exception/1"},{"id":"message/1","anchor":"message/1"}]},{"id":"Guardian.Permissions.Bitwise.PermissionNotFoundError","title":"Guardian.Permissions.Bitwise.PermissionNotFoundError","group":"","functions":[{"id":"exception/1","anchor":"exception/1"},{"id":"message/1","anchor":"message/1"}]},{"id":"Guardian.Plug.UnauthenticatedError","title":"Guardian.Plug.UnauthenticatedError","group":"","functions":[{"id":"exception/1","anchor":"exception/1"},{"id":"message/1","anchor":"message/1"}]}],"modules":[{"id":"Guardian","title":"Guardian","group":"","callbacks":[{"id":"after_encode_and_sign/4","anchor":"c:after_encode_and_sign/4"},{"id":"after_sign_in/5","anchor":"c:after_sign_in/5"},{"id":"before_sign_out/3","anchor":"c:before_sign_out/3"},{"id":"build_claims/3","anchor":"c:build_claims/3"},{"id":"on_exchange/3","anchor":"c:on_exchange/3"},{"id":"on_refresh/3","anchor":"c:on_refresh/3"},{"id":"on_revoke/3","anchor":"c:on_revoke/3"},{"id":"on_verify/3","anchor":"c:on_verify/3"},{"id":"resource_from_claims/1","anchor":"c:resource_from_claims/1"},{"id":"subject_for_token/2","anchor":"c:subject_for_token/2"},{"id":"verify_claims/2","anchor":"c:verify_claims/2"}],"functions":[{"id":"decode_and_verify/4","anchor":"decode_and_verify/4"},{"id":"encode_and_sign/4","anchor":"encode_and_sign/4"},{"id":"exchange/5","anchor":"exchange/5"},{"id":"peek/2","anchor":"peek/2"},{"id":"refresh/3","anchor":"refresh/3"},{"id":"resource_from_token/4","anchor":"resource_from_token/4"},{"id":"revoke/3","anchor":"revoke/3"},{"id":"stringify_keys/1","anchor":"stringify_keys/1"},{"id":"timestamp/0","anchor":"timestamp/0"}],"types":[{"id":"conditional_tuple/0","anchor":"t:conditional_tuple/0"},{"id":"options/0","anchor":"t:options/0"}]},{"id":"Guardian.Config","title":"Guardian.Config","group":"","functions":[{"id":"resolve_value/1","anchor":"resolve_value/1"}],"types":[{"id":"config_value/0","anchor":"t:config_value/0"}]},{"id":"Guardian.Token.Jwt.SecretFetcher","title":"Guardian.Token.Jwt.SecretFetcher","group":"","callbacks":[{"id":"fetch_signing_secret/2","anchor":"c:fetch_signing_secret/2"},{"id":"fetch_verifying_secret/3","anchor":"c:fetch_verifying_secret/3"}]},{"id":"Guardian.Token","title":"Guardian.Token","group":"Tokens","callbacks":[{"id":"build_claims/5","anchor":"c:build_claims/5"},{"id":"create_token/3","anchor":"c:create_token/3"},{"id":"decode_token/3","anchor":"c:decode_token/3"},{"id":"exchange/5","anchor":"c:exchange/5"},{"id":"peek/2","anchor":"c:peek/2"},{"id":"refresh/3","anchor":"c:refresh/3"},{"id":"revoke/4","anchor":"c:revoke/4"},{"id":"token_id/0","anchor":"c:token_id/0"},{"id":"verify_claims/3","anchor":"c:verify_claims/3"}],"types":[{"id":"claims/0","anchor":"t:claims/0"},{"id":"decoding_error/0","anchor":"t:decoding_error/0"},{"id":"encoding_error/0","anchor":"t:encoding_error/0"},{"id":"resource/0","anchor":"t:resource/0"},{"id":"secret_error/0","anchor":"t:secret_error/0"},{"id":"signing_error/0","anchor":"t:signing_error/0"},{"id":"token/0","anchor":"t:token/0"},{"id":"ttl/0","anchor":"t:ttl/0"}]},{"id":"Guardian.Token.Jwt","title":"Guardian.Token.Jwt","group":"Tokens","functions":[{"id":"build_claims/5","anchor":"build_claims/5"},{"id":"create_token/3","anchor":"create_token/3"},{"id":"decode_token/3","anchor":"decode_token/3"},{"id":"exchange/5","anchor":"exchange/5"},{"id":"peek/2","anchor":"peek/2"},{"id":"refresh/3","anchor":"refresh/3"},{"id":"revoke/4","anchor":"revoke/4"},{"id":"token_id/0","anchor":"token_id/0"},{"id":"verify_claims/3","anchor":"verify_claims/3"}]},{"id":"Guardian.Token.Jwt.Verify","title":"Guardian.Token.Jwt.Verify","group":"Tokens","functions":[{"id":"verify_claims/3","anchor":"verify_claims/3"}]},{"id":"Guardian.Token.Verify","title":"Guardian.Token.Verify","group":"Tokens","callbacks":[{"id":"verify_claim/4","anchor":"c:verify_claim/4"}],"functions":[{"id":"time_within_drift?/1","anchor":"time_within_drift?/1"},{"id":"time_within_drift?/2","anchor":"time_within_drift?/2"},{"id":"verify_literal_claims/3","anchor":"verify_literal_claims/3"}]},{"id":"Guardian.Plug","title":"Guardian.Plug","group":"Plugs","functions":[{"id":"authenticated?/2","anchor":"authenticated?/2"},{"id":"current_claims/2","anchor":"current_claims/2"},{"id":"current_resource/2","anchor":"current_resource/2"},{"id":"current_token/2","anchor":"current_token/2"},{"id":"default_key/0","anchor":"default_key/0"},{"id":"put_current_claims/3","anchor":"put_current_claims/3"},{"id":"put_current_resource/3","anchor":"put_current_resource/3"},{"id":"put_current_token/3","anchor":"put_current_token/3"},{"id":"remember_me/5","anchor":"remember_me/5"},{"id":"remember_me_from_token/5","anchor":"remember_me_from_token/5"},{"id":"session_active?/1","anchor":"session_active?/1"},{"id":"sign_in/5","anchor":"sign_in/5"},{"id":"sign_out/3","anchor":"sign_out/3"}]},{"id":"Guardian.Plug.EnsureAuthenticated","title":"Guardian.Plug.EnsureAuthenticated","group":"Plugs","functions":[{"id":"respond/1","anchor":"respond/1"}]},{"id":"Guardian.Plug.EnsureNotAuthenticated","title":"Guardian.Plug.EnsureNotAuthenticated","group":"Plugs","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"}]},{"id":"Guardian.Plug.Keys","title":"Guardian.Plug.Keys","group":"Plugs","functions":[{"id":"key_from_other/1","anchor":"key_from_other/1"}]},{"id":"Guardian.Plug.LoadResource","title":"Guardian.Plug.LoadResource","group":"Plugs","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"}]},{"id":"Guardian.Plug.Pipeline","title":"Guardian.Plug.Pipeline","group":"Plugs","functions":[{"id":"__using__/1","anchor":"__using__/1"},{"id":"call/2","anchor":"call/2"},{"id":"current_error_handler/1","anchor":"current_error_handler/1"},{"id":"current_key/1","anchor":"current_key/1"},{"id":"current_module/1","anchor":"current_module/1"},{"id":"fetch_error_handler/2","anchor":"fetch_error_handler/2"},{"id":"fetch_error_handler!/2","anchor":"fetch_error_handler!/2"},{"id":"fetch_key/2","anchor":"fetch_key/2"},{"id":"fetch_module/2","anchor":"fetch_module/2"},{"id":"fetch_module!/2","anchor":"fetch_module!/2"},{"id":"init/1","anchor":"init/1"},{"id":"put_error_handler/2","anchor":"put_error_handler/2"},{"id":"put_key/2","anchor":"put_key/2"},{"id":"put_module/2","anchor":"put_module/2"}]},{"id":"Guardian.Plug.VerifyCookie","title":"Guardian.Plug.VerifyCookie","group":"Plugs","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"}]},{"id":"Guardian.Plug.VerifyHeader","title":"Guardian.Plug.VerifyHeader","group":"Plugs","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"}]},{"id":"Guardian.Plug.VerifySession","title":"Guardian.Plug.VerifySession","group":"Plugs","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"}]},{"id":"Guardian.Phoenix.Socket","title":"Guardian.Phoenix.Socket","group":"Phoenix","functions":[{"id":"assign_rtc/5","anchor":"assign_rtc/5"},{"id":"authenticate/5","anchor":"authenticate/5"},{"id":"authenticated?/2","anchor":"authenticated?/2"},{"id":"current_claims/2","anchor":"current_claims/2"},{"id":"current_resource/2","anchor":"current_resource/2"},{"id":"current_token/2","anchor":"current_token/2"},{"id":"put_current_claims/3","anchor":"put_current_claims/3"},{"id":"put_current_resource/3","anchor":"put_current_resource/3"},{"id":"put_current_token/3","anchor":"put_current_token/3"}]},{"id":"Guardian.Permissions.Bitwise","title":"Guardian.Permissions.Bitwise","group":"Permissions","functions":[{"id":"call/2","anchor":"call/2"},{"id":"init/1","anchor":"init/1"},{"id":"max/0","anchor":"max/0"}],"types":[{"id":"input_label/0","anchor":"t:input_label/0"},{"id":"input_permissions/0","anchor":"t:input_permissions/0"},{"id":"input_set/0","anchor":"t:input_set/0"},{"id":"label/0","anchor":"t:label/0"},{"id":"permission_set/0","anchor":"t:permission_set/0"},{"id":"plug_option/0","anchor":"t:plug_option/0"},{"id":"t/0","anchor":"t:t/0"}]}],"tasks":[{"id":"Mix.Tasks.Guardian.Gen.Secret","title":"guardian.gen.secret","group":""}]}